"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getJoiValidationErrors = getJoiValidationErrors;
exports.defaultISODateNowFunc = defaultISODateNowFunc;
exports.dateISOValidation = dateISOValidation;

var _joi = _interopRequireDefault(require("@hapi/joi"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function getJoiValidationErrors(err) {
  var _err$details;

  if (err === null || err === void 0 ? void 0 : (_err$details = err.details) === null || _err$details === void 0 ? void 0 : _err$details.length) {
    var details = JSON.parse(JSON.stringify(err.details));
    var joiData = details.map(function (x) {
      return x.message.replace(new RegExp('"', "g"), "");
    });
    return joiData.join("; ");
  }

  return "";
}

function defaultISODateNowFunc() {
  return new Date().toISOString();
}

function dateISOValidation() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      isRequired = _ref.isRequired,
      defaultVal = _ref.defaultVal;

  if (isRequired === true) {
    if (defaultVal) {
      return _joi["default"].string().isoDate().required().strict(false)["default"](defaultVal);
    }

    return _joi["default"].string().isoDate().required().strict(false);
  }

  if (defaultVal) {
    return _joi["default"].string().isoDate().strict(false).allow(null)["default"](defaultVal);
  }

  return _joi["default"].string().isoDate().strict(false).empty("").allow(null)["default"](null);
}