"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.DynamoFilterQueryMixin = void 0;

var _errors = require("../helpers/errors.js");

var _dynamoFilterQueryOperation = require("./dynamo-filter-query-operation.js");

var _dynamoQueryScanProcessor = require("./dynamo-query-scan-processor.js");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function applyMixins(derivedCtor, baseCtors) {
  baseCtors.forEach(function (baseCtor) {
    Object.getOwnPropertyNames(baseCtor.prototype).forEach(function (name) {
      Object.defineProperty(derivedCtor.prototype, name, Object.getOwnPropertyDescriptor(baseCtor.prototype, name));
    });
  });
}

var DynamoFilterQueryMixin = /*#__PURE__*/function () {
  function DynamoFilterQueryMixin() {
    _classCallCheck(this, DynamoFilterQueryMixin);
  }

  _createClass(DynamoFilterQueryMixin, [{
    key: "allHelpValidateRequiredNumber",
    value: function allHelpValidateRequiredNumber(keyValueValidates) {
      var errors = [];
      Object.entries(keyValueValidates).forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            key = _ref2[0],
            value = _ref2[1];

        if (!(!isNaN(Number(value)) && typeof value === "number")) {
          errors.push("".concat(key, " is required"));
        }
      });

      if (errors.length) {
        throw new _errors.GenericDataError("".concat(errors.join("; "), "."));
      }
    }
  }, {
    key: "allHelpValidateRequiredString",
    value: function allHelpValidateRequiredString(keyValueValidates) {
      var errors = [];
      Object.entries(keyValueValidates).forEach(function (_ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            key = _ref4[0],
            value = _ref4[1];

        if (!(value && typeof value === "string")) {
          errors.push("".concat(key, " is required"));
        }
      });

      if (errors.length) {
        throw new _errors.GenericDataError("".concat(errors.join("; "), "."));
      }
    }
  }]);

  return DynamoFilterQueryMixin;
}();

exports.DynamoFilterQueryMixin = DynamoFilterQueryMixin;
applyMixins(DynamoFilterQueryMixin, [//
_dynamoFilterQueryOperation.DynamoFilterQueryOperation, _dynamoQueryScanProcessor.DynamoQueryScanProcessor]);
var _default = DynamoFilterQueryMixin;
exports["default"] = _default;