"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.coreSchemaDefinition = void 0;

var _joi = _interopRequireDefault(require("@hapi/joi"));

var _baseJoiHelper = require("./base-joi-helper.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var coreSchemaDefinition = {
  id: _joi["default"].string().required().min(3).max(80),
  partitionSegment: _joi["default"].string().required().min(3).max(80),
  //
  lastModifierUserId: _joi["default"].string().allow(null).empty("")["default"](null),
  lastModifiedDate: (0, _baseJoiHelper.dateISOValidation)(),
  //
  creatorUserId: _joi["default"].string().allow(null).empty("")["default"](null),
  createdAtDate: (0, _baseJoiHelper.dateISOValidation)({
    isRequired: true
  }),
  //
  deleterUserId: _joi["default"].string().allow(null).empty("")["default"](null),
  isDeleted: _joi["default"]["boolean"]()["default"](false)
};
exports.coreSchemaDefinition = coreSchemaDefinition;