"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DynamoQueryScanProcessor = void 0;

var _connection = require("../test/connection.js");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DynamoQueryScanProcessor = /*#__PURE__*/function () {
  function DynamoQueryScanProcessor() {
    _classCallCheck(this, DynamoQueryScanProcessor);
  }

  _createClass(DynamoQueryScanProcessor, [{
    key: "__helperDynamoQueryProcessor",
    //
    value: function () {
      var _helperDynamoQueryProcessor = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
        var evaluationLimit, params, pageSize, lastKeyHash, orderDesc, hashKeyAndSortKey;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                evaluationLimit = _ref.evaluationLimit, params = _ref.params, pageSize = _ref.pageSize, lastKeyHash = _ref.lastKeyHash, orderDesc = _ref.orderDesc, hashKeyAndSortKey = _ref.hashKeyAndSortKey;
                _context.next = 3;
                return this.__helperDynamoQueryScanProcessor({
                  operation: "query",
                  evaluationLimit: evaluationLimit,
                  params: params,
                  pageSize: pageSize,
                  lastKeyHash: lastKeyHash,
                  orderDesc: orderDesc,
                  hashKeyAndSortKey: hashKeyAndSortKey
                });

              case 3:
                return _context.abrupt("return", _context.sent);

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function __helperDynamoQueryProcessor(_x) {
        return _helperDynamoQueryProcessor.apply(this, arguments);
      }

      return __helperDynamoQueryProcessor;
    }()
  }, {
    key: "__helperDynamoScanProcessor",
    value: function () {
      var _helperDynamoScanProcessor = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2) {
        var evaluationLimit, params, pageSize, lastKeyHash;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                evaluationLimit = _ref2.evaluationLimit, params = _ref2.params, pageSize = _ref2.pageSize, lastKeyHash = _ref2.lastKeyHash;
                _context2.next = 3;
                return this.__helperDynamoQueryScanProcessor({
                  operation: "scan",
                  evaluationLimit: evaluationLimit,
                  params: params,
                  pageSize: pageSize,
                  lastKeyHash: lastKeyHash
                });

              case 3:
                return _context2.abrupt("return", _context2.sent);

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function __helperDynamoScanProcessor(_x2) {
        return _helperDynamoScanProcessor.apply(this, arguments);
      }

      return __helperDynamoScanProcessor;
    }()
  }, {
    key: "__helperDynamoQueryScanProcessor",
    value: function __helperDynamoQueryScanProcessor(_ref3) {
      var _this = this;

      var operation = _ref3.operation,
          evaluationLimit = _ref3.evaluationLimit,
          params = _ref3.params,
          pageSize = _ref3.pageSize,
          lastKeyHash = _ref3.lastKeyHash,
          orderDesc = _ref3.orderDesc,
          hashKeyAndSortKey = _ref3.hashKeyAndSortKey;
      var xDefaultEvaluationLimit = 10;
      var xMinEvaluationLimit = 5;
      var xMaxEvaluationLimit = 500;
      console.log({
        processorParams: {
          operation: operation,
          pageSize: pageSize,
          orderDesc: orderDesc,
          lastKeyHash: lastKeyHash,
          evaluationLimit: evaluationLimit,
          hashKeyAndSortKey: hashKeyAndSortKey
        }
      });
      return new Promise(function (resolve, reject) {
        var returnedItems = [];
        var _evaluationLimit = 0;

        if (pageSize) {
          //
          _evaluationLimit = xDefaultEvaluationLimit;

          if (evaluationLimit) {
            _evaluationLimit = evaluationLimit;
          }

          if (_evaluationLimit < xMinEvaluationLimit) {
            _evaluationLimit = xMinEvaluationLimit; //
          } else if (_evaluationLimit > xMaxEvaluationLimit) {
            _evaluationLimit = xDefaultEvaluationLimit;
          }

          if (pageSize > _evaluationLimit) {
            _evaluationLimit = pageSize + 1; //
          } else if (pageSize === _evaluationLimit) {// _evaluationLimit = pageSize + 1;
          }
        }

        var queryScanUntilDone = function queryScanUntilDone(err, data) {
          if (err) {
            var _returnedItems;

            console.log(err, err.stack);

            if ((_returnedItems = returnedItems) === null || _returnedItems === void 0 ? void 0 : _returnedItems.length) {
              resolve({
                mainResult: returnedItems
              });
            } else {
              reject(err.stack);
            }
          } else {
            var _data$Items;

            if (data === null || data === void 0 ? void 0 : (_data$Items = data.Items) === null || _data$Items === void 0 ? void 0 : _data$Items.length) {
              returnedItems = [].concat(_toConsumableArray(returnedItems), _toConsumableArray(data.Items));
            }

            if (returnedItems.length && (hashKeyAndSortKey === null || hashKeyAndSortKey === void 0 ? void 0 : hashKeyAndSortKey.length)) {
              var dataObj = returnedItems.slice(-1)[0];

              var customLastEvaluationKey = _this.__createCustomLastEvaluationKey(dataObj, hashKeyAndSortKey);

              console.log({
                customLastEvaluationKey: customLastEvaluationKey
              });
            }

            if (pageSize && returnedItems.length >= pageSize) {
              var scanResult = {
                mainResult: returnedItems
              };

              if (data.LastEvaluatedKey) {
                var _lastKeyHash = _this.__encodeLastKey(data.LastEvaluatedKey);

                scanResult.lastKeyHash = _lastKeyHash;
              }

              resolve(scanResult);
            } else if (data.LastEvaluatedKey) {
              var _paramsDef = _objectSpread({}, params);

              _paramsDef.ExclusiveStartKey = data.LastEvaluatedKey;

              if (_evaluationLimit) {
                _paramsDef.Limit = _evaluationLimit;
              }

              console.log({
                operation: operation,
                dynamoProcessorParams: _paramsDef
              });

              _connection.MyDynamoConnection.dynamoDbClientInst()[operation](_paramsDef, queryScanUntilDone);
            } else {
              resolve({
                mainResult: returnedItems
              });
            }
          }
        };

        var _params = _objectSpread({}, params);

        if (_evaluationLimit) {
          _params.Limit = _evaluationLimit;
        }

        if (lastKeyHash) {
          var _lastEvaluatedKey = _this.__decodeLastKey(lastKeyHash);

          if (_lastEvaluatedKey) {
            _params.ExclusiveStartKey = _lastEvaluatedKey;
          }
        }

        if (orderDesc === true && operation === "query") {
          _params["ScanIndexForward"] = false;
        }

        console.log({
          operation: operation,
          dynamoProcessorParams: _params
        });

        _connection.MyDynamoConnection.dynamoDbClientInst()[operation](_params, queryScanUntilDone);
      });
    }
  }, {
    key: "__encodeLastKey",
    value: function __encodeLastKey(lastEvaluatedKey) {
      return Buffer.from(JSON.stringify(lastEvaluatedKey)).toString("base64");
    }
  }, {
    key: "__createCustomLastEvaluationKey",
    value: function __createCustomLastEvaluationKey(dataObj, primaryFieldNames) {
      var obj = {};
      primaryFieldNames.forEach(function (key) {
        if (typeof dataObj[key] !== "undefined") {
          obj[key] = dataObj[key];
        }
      });
      return Object.keys(obj).length > 0 ? obj : null;
    }
  }, {
    key: "__decodeLastKey",
    value: function __decodeLastKey(lastKeyHash) {
      var _lastEvaluatedKey;

      try {
        var _lastKeyHashStr = Buffer.from(lastKeyHash, "base64").toString();

        _lastEvaluatedKey = JSON.parse(_lastKeyHashStr);
      } catch (error) {
        _lastEvaluatedKey = undefined;
      }

      return _lastEvaluatedKey;
    }
  }]);

  return DynamoQueryScanProcessor;
}();

exports.DynamoQueryScanProcessor = DynamoQueryScanProcessor;