"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UtilService = void 0;

var _uuid = require("uuid");

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var UtilServiceBase = /*#__PURE__*/function () {
  function UtilServiceBase() {
    _classCallCheck(this, UtilServiceBase);
  }

  _createClass(UtilServiceBase, [{
    key: "convertHexadecimalToNumber",

    /** generate uuid */
    value: function convertHexadecimalToNumber(hexString) {
      return parseInt(hexString, 16);
    }
    /**
     * Returns a random number between min (inclusive) and max (exclusive)
     */

  }, {
    key: "getRandomDecimal",
    value: function getRandomDecimal(min, max) {
      return Math.random() * (max - min) + min;
    }
    /**
     * Returns a random integer between min (inclusive) and max (inclusive)
     * Using Math.round() will give you a non-uniform distribution!
     */

  }, {
    key: "getRandomInt",
    value: function getRandomInt(min, max) {
      var minVal = Math.ceil(min);
      var maxVal = Math.floor(max);
      return Math.floor(Math.random() * (maxVal - minVal + 1)) + minVal;
    }
  }, {
    key: "getRandomString",
    value: function getRandomString(count) {
      var text = "";
      var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

      for (var i = 0; i < count; i++) {
        var random = Math.floor(Math.random() * possible.length);
        text += possible[random];
      }

      return text;
    }
  }, {
    key: "getRandomAlphabet",
    value: function getRandomAlphabet(count) {
      var txt = "";
      var alphabets = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

      for (var i = 0; i < count; i++) {
        var random = Math.floor(Math.random() * alphabets.length);
        txt += alphabets[random];
      }

      return txt;
    }
  }, {
    key: "camelCaseToSentenceCase",
    value: function camelCaseToSentenceCase(text) {
      var result = text.replace(/([A-Z])/g, " $1");
      var rst = result.charAt(0).toUpperCase() + result.slice(1);
      return rst.trim();
    }
  }, {
    key: "toTitleCase",
    value: function toTitleCase(text) {
      return text.replace(/\w\S*/g, function (txt) {
        return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
      });
    }
  }, {
    key: "isValidPhoneNumber",
    value: function isValidPhoneNumber(_str) {
      if (isNaN(Number(_str))) {
        return false;
      }

      var isNum = /^\d+$/.test(_str);
      return isNum;
    }
  }, {
    key: "convertObjectPlainObject",
    value: function convertObjectPlainObject(objData) {
      var objDataPlain = JSON.parse(JSON.stringify(objData));
      return objDataPlain;
    }
  }, {
    key: "removeDuplicateString",
    value: function removeDuplicateString(items) {
      if (!Array.isArray(items)) {
        return [];
      }

      var unique = {};
      items.forEach(function (i) {
        if (!unique[i]) {
          unique[i] = true;
        }
      });
      return Object.keys(unique);
    }
  }, {
    key: "objectHasAnyProperty",
    value: function objectHasAnyProperty(obj) {
      if (obj && _typeof(obj) === "object") {
        return Object.keys(obj).length > 0;
      }

      return false;
    }
  }, {
    key: "waitUntilMilliseconds",
    value: function waitUntilMilliseconds(ms) {
      return new Promise(function (resolve, reject) {
        setTimeout(function () {
          resolve();
        }, ms);
      });
    }
  }, {
    key: "waitUntilSeconds",
    value: function waitUntilSeconds(seconds) {
      return new Promise(function (resolve) {
        setTimeout(function () {
          resolve();
        }, Math.round(seconds * 1000));
      });
    }
  }, {
    key: "waitUntilMunites",
    value: function waitUntilMunites(munites) {
      return new Promise(function (resolve) {
        setTimeout(function () {
          resolve();
        }, Math.round(munites * 60 * 1000));
      });
    }
  }, {
    key: "generateDynamoTableKey",
    value: function generateDynamoTableKey(date) {
      var _now = date ? new Date(date) : new Date();

      var key = ["".concat(_now.getFullYear()), "".concat(_now.getMonth() + 1).padStart(2, "0"), "".concat(_now.getDate()).padStart(2, "0"), "-", "".concat(_now.getHours()).padStart(2, "0"), "".concat(_now.getMinutes()).padStart(2, "0"), "".concat(_now.getSeconds()).padStart(2, "0"), "-", (0, _uuid.v4)()];
      return key.join("");
    }
  }]);

  return UtilServiceBase;
}();

var UtilService = new UtilServiceBase();
exports.UtilService = UtilService;