"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MyRepository = void 0;

var _baseRepo = require("./base-repo.js");

var _joi = _interopRequireDefault(require("@hapi/joi"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var schemaSubDef = {
  category: _joi["default"].string().required(),
  amount: _joi["default"].number().min(1),
  invoiceId: _joi["default"].string().empty("")["default"](null).allow(null),
  transactionId: _joi["default"].string().empty("")["default"](null).allow(null),
  remark: _joi["default"].string().empty("")["default"](null).allow(null)
};

var getRandom = function getRandom() {
  return [Math.round(Math.random() * 99999), Math.round(Math.random() * 88), Math.round(Math.random() * 99)].reduce(function (prev, cur) {
    return prev + cur;
  }, 0);
};

var MyRepositoryBase = /*#__PURE__*/function (_BaseRepository) {
  _inherits(MyRepositoryBase, _BaseRepository);

  var _super = _createSuper(MyRepositoryBase);

  function MyRepositoryBase() {
    _classCallCheck(this, MyRepositoryBase);

    return _super.call(this, {
      schemaSubDef: schemaSubDef,
      secondaryIndexOptions: [],
      segmentPartitionValue: "table_users"
    });
  }

  _createClass(MyRepositoryBase, [{
    key: "create",
    value: function () {
      var _create = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.allCreateOneBase({
                  data: {
                    amount: getRandom(),
                    category: getRandom().toString(),
                    invoiceId: getRandom().toString(),
                    remark: getRandom().toString(),
                    transactionId: getRandom().toString()
                  }
                });

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function create() {
        return _create.apply(this, arguments);
      }

      return create;
    }()
  }]);

  return MyRepositoryBase;
}(_baseRepo.BaseRepository);

var MyRepository = new MyRepositoryBase();
exports.MyRepository = MyRepository;
var count = 0;

function runInserts() {
  var tout = setInterval(function () {
    count++;
    console.log({
      count: count
    });

    if (count >= 10) {
      clearInterval(tout);
      process.exit(0);
    } else {
      MyRepository.create()["catch"](function (e) {
        return console.log(e);
      });
    }
  }, 2000);
}

setTimeout(function () {
  console.log("Initializing");
  runInserts();
}, 10); // ts-node ./src/test/repo.ts