import { DynamoDB } from "aws-sdk";
import type { IDynamoPagingResult } from "../types/base-declarations";
export declare abstract class DynamoQueryScanProcessor {
    protected __helperDynamoQueryProcessor<T>({ evaluationLimit, params, pageSize, lastKeyHash, orderDesc, hashKeyAndSortKey, }: {
        evaluationLimit?: number;
        params: DynamoDB.QueryInput;
        pageSize?: number;
        lastKeyHash?: any;
        orderDesc?: boolean;
        hashKeyAndSortKey: [string, string];
    }): Promise<IDynamoPagingResult<T[]>>;
    protected __helperDynamoScanProcessor<T>({ evaluationLimit, params, pageSize, lastKeyHash, }: {
        evaluationLimit?: number;
        params: DynamoDB.ScanInput;
        pageSize?: number;
        lastKeyHash?: any;
    }): Promise<IDynamoPagingResult<T[]>>;
    private __helperDynamoQueryScanProcessor;
    private __encodeLastKey;
    private __createCustomLastEvaluationKey;
    private __decodeLastKey;
}
